#include "planner.hpp"
#include "goap/action_db.hpp"
#include "utils/godot_macros.hpp"

namespace goap {
void Planner::_bind_methods() {
#define CLASSNAME Planner
    GDPROPERTY_HINTED(actions, gd::Variant::PACKED_INT32_ARRAY, gd::PROPERTY_HINT_ENUM, ActionDB::get_enum_hint());
}

void Planner::_enter_tree() {
    this->world_state = this->get_node<ActorWorldState>("../ActorWorldState");
}

Plan Planner::plan_for_goal(gd::Ref<Goal> goal) {
    return {};
}

void Planner::set_actions(gd::PackedInt32Array array) {
    this->actions.clear();
    for(int id : array) {
        Action const *action = ActionDB::get_action(id);
        if(action != nullptr && !this->actions.has(action))
            this->actions.push_back(action);
    }
}

gd::PackedInt32Array Planner::get_actions() const {
    gd::PackedInt32Array array{};
    for(Action const *action : this->actions)
        action->get_id();
    return array;
}
}
